/*
  Uebung 2 : Das Pascalsche Dreieck
  @author Markus Jbstl
  @version 1.1
  
 */

public class Uebung2
{
   final static int N=9;  /* Zeilenanzahl */

    static public void main(String args[])
    {
        System.out.println("Programmstart\n\n");
        int i,j;    /* Schleifenvariablen */
        /* Wird in einer Dreiecksmatrix gespeichert */
        long[][] triangle=new long[N][];
        for(i=0;i<N;i++)
        {
            triangle[i]=new long[i+1]; /* Die neue Zeile anlegen (Zeile 0 hat 1 Element) */
            triangle[i][0]=1; /* Erster Wert in jeder Zeile ist 1 */
            for(j=1;j<i;j++)    /* Zahl im Dreieck ist Summe der beiden darueberliegenden Zahlen */
                triangle[i][j]=triangle[i-1][j-1]+triangle[i-1][j];
            triangle[i][i]=1; /* Letzter Wert in jeder Zeile ist 1 */
        }
        /* Formatiert als Dreieck ausgeben (geht nur bei fixed-width-font) */
        /* Berechnung der Mitte fr die erste Zeile ( Annahme man reseviert 5 Zeichen pro Zahl*/
        int pos = ((N*5) + (N-1)) / 2 -1;

        for(i=0;i<N;i++)   /* Schleife fuer die Zeilen */
        {
            String line="";

            for(int k=0;k<pos;k++)  /* Wegen Dreiecksform erst einige Leerzeichen ausgeben */
                line+=" ";
            for(int k=0;k<=i;k++)   /* Schleife ueber die Zahlen der Zeile */
            {
                line+="  ";
                line+=triangle[i][k]; /* Zahl  ausgeben */
                line+=(triangle[i][k] > 9 ?"  ":"   ");   /* zweistellige Zahlen bercksichtigen */
            }
            System.out.println(line);
            pos -=3;
        }
        System.out.println("\n\nProgrammende");
    }

}

